// $Id: TKqmlUtil.C,v 1.4 1997/05/30 17:52:07 ian Exp $

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <tcl.h>
#include <tk.h>
#include <TKqml.h>
#include <TKqmlUtil.h>

// accepts s = "[copq][0-9A-F]*", exactly TKQML_PTR_LEN characters.
// places pointer representation of s in *i.
int ptr_string(char *s, void **i) { 
  int j, k=0;

  if (nullstr(s)) { *i=(void*)NULL; return(TRUE); } // legal null
  if (strlen(s)!=TKQML_PTR_LEN) return(FALSE);
  for (j=1; j<TKQML_PTR_LEN; j++) 
    if (dig16(s[j])==ERR) return(FALSE);                      // illegal char
  *i=(void *)atop(s);
  return(TRUE);
}

// This function defines null character string
int nullstr(char *string) {
  if (strcmp(string,"NULL")==0) return(TRUE);
  else if (strcmp(string,"null")==0) return(TRUE);
  else if (strcmp(string,"")==0) return(TRUE);
  else return(FALSE);
}

// Interconverters

// integer -> string
char *itoa(int n) {
  char *str;
  int len;

  if (n<1) return("0");
  len=1+(int)floor(log10((double)n));
  str=(char *)malloc(len+1);
  str[len]='\0';
  while((--len)>=0) {
    str[len]=(char)('0'+(n-((n/10)*10)));
    n/=10;
  }
  return(str);
}

char *ptoa(void *p, char type) {                     // void pointer -> string
  char *s;
  unsigned long int i;
  int j,n;

  s=(char *)calloc(10, sizeof(char));

  i = (unsigned long int)p;
  if ((n = sprintf(s, "%c%8.8lX", type, i)) < 0)
  {
      fprintf(stderr, "Error sprintf'ing pointer\n");
      exit(-1);
  }
  return(s);
}

int dig10(char c) {
  return ( ((c>='0')&&(c<='9')) ? (int)(c-'0') : ERR );
}

int dig16(char c) {
    return ( ((c>='A')&&(c<='F')) ? (int)(c-'A'+10) : dig10(c) );
}

void *atop(char *s) {                 // (assumed valid )string -> void pointer
  unsigned long int i = 0;
  int j, k;
  
  if (strlen(s)!=TKQML_PTR_LEN) return(NULL);             // ill formed pointer

  /* maybe could use strtol instead */
  for (j=1; j<TKQML_PTR_LEN; j++) {
    if ((k=dig16(s[j]))==ERR) return(NULL);
    i = i<<4;
    i+= (unsigned long int)k;
  }
  return((void *)i);
}

char *deref(char *s) {
  void *p, **q;
  char *target;

  if (!s) return NULL;
  if (strcmp(s, "NULL") == 0) return NULL;
  if (s[0] != TKQML_PPOBJ_TYPE) return NULL;

  p = atop(s);
  q = (void**)p;
  target = ptoa((void*)*q, TKQML_POBJ_TYPE);
  return target;
}








